#include <forkjoin.hpp>
#include <cstdio>


using namespace typon;

int fibo(int n) {
  if (n < 2)
    return n;
  return fibo(n - 1) + fibo(n - 2);
}

Fork<void> hello(int i) {
  int n = fibo(10);
  printf("hello from %d on %lu, fibo(40) = %d\n", i, riften::detail::static_id, n);
  co_return;
}

Join<void> parallel() {
  for (int i = 0; i < 30; i++) {
    co_await hello(i);
    printf("parallel resumed on %lu\n", riften::detail::static_id);
  }
  printf("parallel syncing on %lu\n", riften::detail::static_id);
  co_await Sync();
  printf("parallel resumed on %lu\n", riften::detail::static_id);
  for (int i = 30; i < 60; i++) {
    co_await hello(i);
    printf("parallel resumed on %lu\n", riften::detail::static_id);
  }
}

Root root() {
  co_await parallel();
}

int main() {
  root().call();
  puts("done");
  return 0;
}
