#include <forkjoin.hpp>
#include <cstdio>


using namespace typon;

Join<int> fibo(int n);
Fork<int> fork_fibo(int n);

Join<int> fibo(int n) {
  if (n < 2) {
    co_return n;
  }
  Future a = co_await fork_fibo(n - 1);
  Future b = co_await fork_fibo(n - 2);
  co_await Sync();
  co_return a.get() + b.get();
}

Fork<int> fork_fibo(int n) {
  co_return co_await fibo(n);
}

Root root() {
  int result = co_await fibo(40);
  printf("%d\n", result);
}

int main() {
  root().call();
  puts("done");
  return 0;
}
